/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidGirlfriend(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var frigid = ctrl.maid.get() === FarmerMaidMaidChoice.RESIST;
        var eager = ctrl.maid.get() === FarmerMaidMaidChoice.ABIDE;
        var hand = ctrl.parents.get() === ctrl.parentsChoice.HANDJOB;
        var toReturn = `[p]
                            After that day, you feared that the eagle's demands would only grow [i]worse[/i].
                            Since he'd had a taste of what being [i]properly[/i] pleasured felt like,
                            you figure he'd be coming back for more before long.
                            You're fully prepared for him to ask you to use your ${hand ? `hand` : `mouth`} again,
                            but such a request never comes.
                        [/p]
                        [p]
                            In fact, ever since you ${hand ? `jerked` : `sucked`} him off,
                            Falco seemingly grows less and less interested in abusing ${frigid ? `his mother and you both` : `you`}.
                            Molestation becomes less frequent, he no longer leers at you while you work,
                            and entire days pass by without ${frigid ? `his mother receiving` : ``} any attention fron him at all.
                            Did you ${hand ? `tug` : `suck`} the libido out of him?
                            ${!eager ? `You can only hope you have.` : `You hope not.`}
                        [/p]
                        [p]
                            Life [i]without[/i] having to deal with the boy's daily harassing is quite nice.
                            You peacefully go about your duties cleaning the house,
                            without constantly ${frigid ? `stumbling upon Juliet in peril` : `being fondled`}.
                            You get some good sleep,
                            you no longer need to clean jizz off the floor${frigid ? `` : `, or off yourself,`}
                            and Romeo's bountiful harvest puts a little more food onto your plate.
                            He's pleased with your performance as of late.
                            You take pride in how [i]pristine[/i] you keep the house.
                            Everyone is happy.
                        [/p]
                        [p]
                            Falco no longer spends most of his time around the house.
                            He's often absent, and he doesn't tell anyone where he's going.
                            You wonder what's going on,
                            but at the same time you don't really [i]care[/i].
                            You're better off without him.
                            The entire family is.
                        [/p]
                        [p]
                            About a month after the ${hand ? `handjob` : `blowjob`},
                            the reason for the avian's frequent absence is revealed.
                            During the afternoon, he comes home together with a young human girl,
                            who you reckon to be no older than nineteen.
                            She looks kind of like Juliet.
                            The two make out in the living room for a while,
                            before heading upstairs and loudly [b]fucking[/b] in the boy's room.
                            No wonder he isn't interested in ${frigid ? `you or his mother` : `you`} anymore.
                            He found someone who [b]willingly[/b] spreads her legs for him.
                        [/p]
                        [p]
                            Over the course of the next few months,
                            the relationship between the eagle and his [i]girlfriend[/i] deepens.
                            At first, they only [i]fool around[/i] while Romeo and his wife are out of the house.
                            Once the news of their romance reaches the avian's parents,
                            the bird and his broad no longer bother to hide their intimacy.
                            The young woman eats dinner with the family,
                            they openly kiss in front of the older couple,
                            and Falco is quite [i]blatant[/i] when suggesting they should retire to his room for the night.
                        [/p]
                        [p]
                            Still, you have no reason to complain.
                            Besides a few extra stains on the feathery teen's bedsheets,
                            the interspecies love affair has no effect on you.
                            If anything, you feel better knowing that everything worked out fine in the end.
                            For you, ${frigid ? `for his mother,` : ``} and for the avian.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
