/**
 * Swim section of the forest river.
 * @param {ForestRiverController} controller The Forest, River controller.
 */
function ForestRiverHands(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ForestRiverFreezeChoice.HANDS;
    var reqController = ctrl.freeze;
    var subController = ctrl.handsUp;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new ForestRiverHandsSpread(ctrl);
    var secondNext =  new ForestRiverHandsStruggle(ctrl);
    var thirdNext =  new ForestRiverHandsKick(ctrl);

    var firstChoice = ForestRiverHandsChoice.SPREAD;
    var secondChoice = ForestRiverHandsChoice.STRUGGLE;
    var thirdChoice = ForestRiverHandsChoice.KICK;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.forestToVaranar.riverHandsUp = true;
        var stripped = ctrl.swim.get() === ForestRiverSwimChoice.STRIP;
        var male = ctrl.misc.dick();
        var underwear = ctrl.misc.underwear();
        var underwearTT = global.kobold.inventory.createItemWithTooltip(underwear);
        var pants = ctrl.misc.pants();
        var pantsTT = global.kobold.inventory.createItemWithTooltip(pants);
        var toReturn = `[p]
                            You have no choice but to comply.
                            Even [i]if[/i] you could manage to knock out the big dude, his friends would pelt you with rocks.
                            They don't seem very [i]skilled[/i] at accurately flinging stones,
                            but one lucky hit is all they need to [b]crack open[/b] your skull.
                            While arrows and bolts are undoubtedly more useful in combat,
                            due to bows and crossbows being a lot easier to aim,
                            you fear slings and slingshots far more for some reason. 
                            Perhaps they're more [i]kobold-like[/i] weapons, triggering primal, fearful reactions in the back of your mind.
                            The thought of your head being hit by a crude rock whirring through the air, leaves you rightfully scared for your very life.
                        [/p]
                        [p]
                            The men have you figuratively cornered.
                            You can't fight all three of them, and you don't see how swimming away could turn out in your favor.
                            Either the weapon-toting humans strike you down,
                            or the buff guy catches up to you and rips a few limbs off before fucking the shit out of your mangled corpse.
                            You're already somewhat tired.
                            Even if you could manage to make it to the other side of the river,
                            you'd be too worn out to make a run for the hamlet.
                        [/p]
                        [p]
                            So you can't run, and you can't fight.
                            That leaves only one option.
                            With a defeated sigh, you reluctantly raise your hands up in the air,
                            [b]surrendering[/b] to the approaching burly bandit and his pair of unsavory fellows.
                            With some luck, you might make it out of here [i]alive[/i].
                            Heck, maybe they won't even take your coins if all the strong man wants is to [i]fuck[/i].
                            But then again, he could easily have [b]both[/b].
                        [/p]
                        [p]
                            You tread water in-place,
                            while the enormous human makes his way over to you.
                            The closer he gets, the lower your heart sinks.
                            He's going to fuck you, and then he's going to take your money.
                            You'll be sent right back to square one.
                            Without a coin to your name, and not even your virginity left to sell.
                            And there's nothing you can do about it.
                            You have surrendered yourself, not only to him, but to [b]fate[/b].
                        [/p]
                        [p]
                            The man comes to a halt directly in front of you.
                            He wordlessly grabs both of your raised wrists with a single one of his oversized hands,
                            and easily hoists your entire ${stripped ? `naked` : ``} body up high, lifting you out of the water.
                            You are left submerged only from the knees-down, a cold draft rolling over your wet, scaly body, chilling you to the bone.
                            If he wanted to [b]freeze[/b] you to death, then he's doing a pretty good job so far.
                            The human looks back at his comrades ashore.
                        [/p]
                        [p]
                            [big]"[color=green]Looks like I caught myself a kobold, boys![/color]"[/big]
                        [/p]
                        [p]
                            The strong man's friends burst out into laughter, lowering their weapons.
                            Now that their leader has his hands on you, you're not going anywhere.
                            "[color=cyan]Sic'em, Goliath! Bash its brains in! Show it who's boss around here![/color]"
                            [i]Goliath[/i]?
                            Fitting name.
                            "[color=green]Hah! Only if it struggles!
                            I don't want to fuck an unresponsive sack of flesh and scales.[/color]"
                        [/p]
                        [p]
                            The human's attention turns back towards you, a menacing glare on his face.
                            He balls his free hand up into a fist, and threatening presses his knuckles against your cheek.
                            Lowering the volume of his voice from a shout down to an ominous whisper, he speaks once more:
                            "[color=green]My fists are aching to pound someone, but so is my dick.
                            I'll let you live, [b]for now[/b].
                            Don't make me regret it.[/color]"
                            The man lustfully licks his lips, inspecting your body from head to groin.
                            His hand moves from your cheek, down your throat, towards your chest.
                            There, he cups the purse hanging off your neck.
                        [/p]
                        [p]
                            "[color=green]Nice bag of gold you've got here.
                            What is that, twenty coins?
                            Thirty?[/color]"
                            Thank goodness Goliath is as dumb as he looks.
                            Or maybe he's just bad at estimating amounts.
                            Or so [b]strong[/b] that he can't tell the difference between the weight of two hundred pieces of gold, and the weight of twenty.
                            Whatever the reason for his improper guess, you don't correct his foolishness.
                            "[color=green]My friends haven't noticed.
                            They think you're poor.
                            Coinless, like the rest of your kind.
                            Struggle, and you'll walk out of here raped [b]and[/b] robbed.
                            Consider it your payment, lizard whore.[/color]"
                        [/p]
                        [p]
                            That said, the human's hand travels downwards along your body, towards your groin.
                            He ${stripped ? `presses the tips of his thick fingers against your tightly clenched thighs,
                            and attempts to wriggle them in between your closed legs.
                            ` : `slips the tips of his thick fingers underneath the waistband of your ${male ? underwearTT : pantsTT},
                            and attempts to wriggle them in between your tightly clenched thighs.`}
                            He seems dead-set on getting a piece of ass, and you doubt he'll take [i]no[/i] for an answer.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Spread</button>`;

        var tooltip = global.parser.parse(`Play along. Spread your legs. Be a good little whore.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Struggle</button>`;

        var tooltip = global.parser.parse(`Fight against the human's grasp, but don't outright assault him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Kick</button>`;

        var tooltip = global.parser.parse(`Kick him and make a run for it!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 220px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var ForestRiverHandsChoice = {
    SPREAD: 1,
    STRUGGLE: 2,
    KICK: 3
};

