/**
 * Enum representing all kinds of genders.
 */
var GenderEnum = {
    // Guaranteed support.
    MALE: 1,
    FEMALE: 2,
    // Optional additions.
    SHEMALE: 3,
    HERMAPHRODITE: 4,
    CUNTBOY: 5,
    // Probably unsupported.
    MALEHERM: 6,
    NONE: 7
};

GenderEnum.properties = {
    1: {symbol: "M", icon:"res/img/genders/male.png", name: "Male", baseGender: GenderEnum.MALE},
    2: {symbol: "F", icon:"res/img/genders/female.png", name: "Female", baseGender: GenderEnum.FEMALE},
    3: {symbol: "S", icon:"res/img/genders/shemale.png", name: "Shemale", baseGender: GenderEnum.FEMALE},
    4: {symbol: "H", icon:"res/img/genders/herm.png", name: "Hermaphrodite", baseGender: GenderEnum.FEMALE},
    5: {symbol: "C", icon:"res/img/genders/cuntboy.png", name: "Cuntboy", baseGender: GenderEnum.MALE},
    6: {symbol: "W", icon:"res/img/genders/mherm.png", name: "Male hermaphrodite", baseGender: GenderEnum.MALE},
    7: {symbol: "N", icon:"res/img/genders/none.png", name: "None", baseGender: GenderEnum.MALE}
};
