/**
 * What the kobold did in the farmer house.
 */
function FarmerHouseShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.went = false;
    this.failed = false;
    this.stole = false;
    this.raped = false;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {FarmerHouseShared-stripped} farmerhouse A FarmerHouseShared object, stripped of private members and all functions.
     */
    this.load = function (farmerhouse) {
        if (!farmerhouse) {
            that.load(new FarmerHouseShared());
            return;
        }
        that.went = farmerhouse.went;
        that.failed = farmerhouse.failed;
        that.stole = farmerhouse.stole;
        that.raped = farmerhouse.raped;
    };
}

