/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkTrick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.TRICK;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.satisfied;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Fine.
                            He can do it inside of you.
                            But only this once, okay?
                        [/p]
                        [p]
                            As those words leave your muzzle, it's like a [b]spark[/b] ignites in Falco's eyes.
                            You grab his half-hard shaft, but instead of guiding it into your pregnant slit,
                            you press it against your folds, and wrap your warm, scaly thighs around it, giving the [i]illusion[/i] that he's inside of you.
                            Sneakily, you lean down and grab your bucket, holding it in front of you to make sure he doesn't make a mess of the floor.
                            The bird leans his weight on you, clutching you tightly, keeping you in place to make sure you don't get any [i]second thoughts[/i].
                            Then, with a satisfied sigh, he releases his bladder, his warm, dark, dehydrated,
                            drunk piss squirting from the foreskin covered tip of his member right into the bucket.
                        [/p]
                        [p]
                            The wasted eagle barely even questions the sounds of his piss hitting the wooden bucket.
                            Your [i]lover[/i] pees like a horse.
                            Maybe it's just because he's drunk, but still you're glad you didn't let him go inside of you.
                            Some twenty seconds of urination later,
                            Falco's bladder is completely emptied,
                            and your mop bucket is half-filled.
                            You release your grip on his shaft.
                            Your bird lover sneaks in a few quick kisses, before pulling up his pants once more.
                            He lets go of you and staggers towards the stairway,
                            then stumbles up the stairs and disappears into his room, probably to sleep off his inebriation.
                        [/p]
                        [p]
                            You head outside through the backdoor, and dump the smelly contents of your mop bucket in the backyard.
                            [i]Watering the plants[/i].
                            After a few moments, all that's left from your encounter with your hammered bird friend, is a steamy, muddy puddle.
                            You hope the avian won't ask you for this again.
                            Next time, you might not be able to trick him as easily.
                            But that's a problem for another time.
                            Getting some more fresh air, 
                            you head back into the house, and continue your maid duties.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
