/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidRecover(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.recover;
    var subController = ctrl.preMaid;
    var changeController = ctrl.recover;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidMaid(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.misc.dick();
        var recap = ctrl.gender.get() === FarmerMaidGenderChoice.BLACKOUT;
        var toReturn = `[p]
                            Some time later, you wake up from a deep, troubled period of unconsciousness.
                            You don't know how long you were out.
                            Minutes?
                            Hours?
                            Days?
                            For a moment,
                            you entertain yourself with the idea that the faint memories of you enduring excruciating torture were nigh but [b]dreams[/b].
                            Delirious nightmares.
                            Fantasies, and nothing more.
                            As your senses slowly drift awake,
                            you become aware once more of the [b]crippling[/b] pain coming from your mouth, your hands and your feet.
                            The illusion is quickly shattered.
                            It really [b]did[/b] happen.
                        [/p]
             ${recap ? `[p]
                            Your head hurts.
                            Your [b]everything[/b] hurts.
                            Your teeth have been removed, pulled out one at a time.
                            Your claws suffered the same fate, your fingers and toes half-[b]mutilated[/b] as a result.
                            To make matters worse, your ass has been branded,
                            the insignia scorched on your scales marking your status as a [b]slave[/b].
                        [/p]` : ``}
                        [p]
                            You painstakingly open your heavy eyelids, to find yourself indoors.
                            You are lying curled up inside of a large and rather comfortable basket.
                            Several clumps of fur make you think this used to belong to a feral dog.
                            You wonder if it got its claws and teeth removed as well.
                            You hope it didn't.
                        [/p]
                        [p]
                            The more awake you get, the more your body aches.
                            You groggily come to an upright, seated position.
                            Your hands and feet look [b]terrible[/b].
                            The bleeding has stopped, but your fingers continually twitch like you're some old [i]witch[/i] casting a [b]curse[/b].
                            Your nerves must have gotten seriously damaged.
                        [/p]
                        [p]
                            You keep on trying to rest your teeth atop one another,
                            but the simple fact is that you [b]have none[/b].
                            As a result, you squish your sensitive,
                            hurting gums against one another time after time again,
                            making you wince in pain over and over.
                        [/p]
                        [p]
                            While your senses slowly grow accustomed to being bombarded with constant pain,
                            you look around the room you're in.
                            It looks like a living room,
                            four shabby, half-rotten wooden walls interrupted only by a trio of doors.
                            One to the kitchen, one which you think [i]might[/i] lead outside,
                            and a third to a stairwell.
                        [/p]
                        [p]
                            A big bench-resembling couch with little padding dominates the room.
                            The basket you're in -- which you presume will be your resting spot for the remainder of your stay here -- is next to the couch.
                            Various aging cabinets and cupboards are lined along the dilapidated walls.
                            Not a single piece of art in sight,
                            apart from a small, plain, cheap vase holding a few backyard flowers atop a piece of wooden furniture.
                        [/p]
                        [p]
                            While [b]massive[/b] compared to your shack in the woods,
                            you understand that this is a [i]poor[/i] home, as far as human households go.
                            Then again, besides Seki's workshop and the [i]mansion[/i] across the road from it,
                            [b]every[/b] home in the hamlet is [i]impoverished[/i].
                            You wonder how the farmer was able to [i]afford[/i] you, but you're certain you wouldn't like the answer even if you knew.
                        [/p]
                        [p]
                            Suddenly, movement.
                            Romeo, the man of the house, walks in through the front door.
                            Glistening sweat rolls down his brow.
                            He must be getting home from working the fields or something.
                            His attention immediately turns towards you, his mere gaze inspiring fear.
                            You curl up into a ball once more, clutching your tail, trembling in fear.
                            "[color=red]Finally awake?
                            I was starting to think you'd slip into a coma.[/color]"
                            A coma?!
                            How long were you out for?
                        [/p]
                        [p]
                            The man moves towards one of the cupboards.
                            Opening it, he reaches in and pulls out a maid outfit, suitable for a child, or a kobold like yourself.
                            Did he get that just for you, or is that something his [i]son[/i] used to wear?
                            He tosses the garment towards you.
                            On closer inspection, it's kind of [i]skimpy[/i].
                            You don't think this will cover your butt [b]at all[/b], and it'll [b]barely[/b] conceal your loins!
                        [/p]
                        [p]
                            You try to voice your objections, but speaking without teeth proves to be quite a bit harder than you'd thought.
                            You don't manage to form any coherent words, apart from some rabid mumbling.
                            Realizing you aren't getting your point across, you end with a reluct, teary sigh.
                            "[color=red]Why I bought you?[/color]"
                            No, that's not what you were asking at all, but there's no point trying to correct him.
                            "[color=red]To clean my house, and to shut my son up about wanting a new pet.[/color]"
                        [/p]
                        [p]
                            A [i]pet[/i]?
                            Great.
                            Just what you needed, to be treated like an [b]animal[/b].
                            You give the human a sour, sulking look.
                            "[color=red]Don't even [b]think[/b] about running away.
                            Every man in town knows you're [b]mine[/b].
                            One look at your ass, and they'll know to capture or kill you.
                            If you're lucky, that is.
                            They might want to keep you for themselves,
                            and I can assure you that I am [b]far[/b] from the worst person in this village.[/color]"
                        [/p]
                        [p]
                            Wow, this guy really knows how to lift your spirits, huh?
                            Then again, these farmers [b]aren't[/b] known for being the most [i]charismatic[/i] fellows.
                            "[color=red]As long as you do what you're told, you'll be treated fairly,
                            and we'll even toss some food your way every now and again.[/color]"
                            Well, at least you won't [i]starve[/i].
                            "[color=red]Oh, and while I've already taken away most of your [i]dangerous[/i] bits,
                            you lay even one hand on my wife or my son, and I will make you [b]wish[/b] you were never born.[/color]"
                            He already has.
                        [/p]
              ${male ? `[p]
                            So, you [i]kind of[/i] understand why he took out your claws and your teeth.
                            You don't [b]agree[/b] with him doing those things, but you understand [b]why[/b] he did them.
                            But one thing that you can not wrap your head around is why exactly he turned you into a [b]girl[/b].
                            Unable to properly speak, you give the human a quizzical, upset look through your teary eyes, whilst pointing towards your groin.
                        [/p]
                        [p]
                            "[color=red]Oh right.
                            My cousin in law told me that [i]male[/i] kobolds tend to get [b]territorial[/b] during mating season.
                            I could have [b]neutered[/b] you instead,
                            but I figured the bloodloss from cutting out your balls might have [b]killed[/b] you.
                            You should [b]thank me[/b], really.[/color]"
                            [i]Territorial[/i]?
                            [b]Mating season[/b]?!
                            You don't know what [b]animal[/b] he's talking about,
                            but the human is grossly misinformed on your kind.
                        [/p]
                        [p]
                            But it's too late to complain.
                            The damage is already done.
                            And even [i]if[/i] you could talk properly,
                            you doubt your voice of reason would be heeded.
                            "[color=red]Besides, have you ever heard of a [b]male[/b] maid?
                            I sure haven't.
                            People might start getting the [i]wrong idea[/i] about me or my kid.
                            Not that I plan on fucking you.
                            I have my wife for that.
                            You're a [b]maid[/b].
                            Not a [b]whore[/b].[/color]"
                            While slightly reassuring, this is getting pretty awkward.
                        [/p]` : ``}
                        [p]
                            "[color=red]Your maid duty starts tomorrow.
                            Get some more rest.
                            You look like you could use it.[/color]"
                            No arguing there.
                            You think you could sleep for an entire [b]month[/b] and [b]still[/b] feel like [b]shit[/b].
                            The man gives you an assertive nod,
                            then walks out of the room.
                        [/p]
                        [p]
                            After wiping your tears on the child-sized maid dress,
                            you reluctantly put it on.
                            While not freezing cold, this house isn't very [i]warm[/i], either.
                            You hope the thin fabric will keep you at least [i]somewhat[/i] heated.
                            At least it'll be warmer than sleeping in the nude.
                            You curl up into a ball once more,
                            cuddling up against the edges of the basket you're in,
                            and cry yourself to sleep.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        ctrl.bgm.stopLoop();
        global.ui.applyTheme("hamlet_barn");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
