/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyPantiesWear(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyPantiesChoice.WEAR;
    var reqController = ctrl.panties;
    var subController = false;
    var changeController = ctrl.pantiesWear;

    var autoContinue = true;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.postPanties;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var saphiraMet = global.kobold.history.shared.dragonessPrincess.relation !== DragonessPrincessEnum.UNMET;
        var underwear = ctrl.misc.underwear();
        var underwearPopup = global.kobold.inventory.createItemWithTooltip(underwear);
        var pants = ctrl.misc.pants();
        var pantsPopup = global.kobold.inventory.createItemWithTooltip(pants);
        var loinsCovered = pants || underwear;
        var wearingPanties = underwear && underwear.id === ItemEnum.SILKPANTIES;
        var toReturn = `[p]
                            Alright!
                            A ${wearingPanties ? `new` : ``} pair of panties!
                            And still warm, too, fresh from the dragoness' loins.
                            ${wearingPanties ? `Finally something to replace this old pair with.
                            Apart from the color, they look kind of similar.
                            The blue pair's quite a bit more clean, though.` :
                            underwear ? `Finally, something more fancy to wear around your waist.
                            ${saphiraMet ? `You think you've seen a similar pair somewhere before, but you can't remember where. Oh well.` : ``}
                            ` : `Finally, something to keep your loins warm with.
                            ${saphiraMet ? `You think you've seen a similar pair somewhere before, but you can't remember where. Oh well.` : ``}`}
                        [/p]
                        [p]
                            ${loinsCovered ? `${t3 ? `Like` : `Unlike`} the dragoness, you have no qualms with getting naked in front of another lizard.
                            ${pants && underwear ? `You take off your ${pantsPopup} and your ${underwearPopup},
                            discarding the latter.` : pants ? `You take off your ${pantsPopup},
                            your bare groin revealed.` : `You take off your ${underwearPopup} and discard the piece of clothing.`}` : `Already
                            naked from the waist-down, you obviously have no qualms with being naked in front of another lizard,
                            ${t3 ? `and neither does the dragoness, apparently.` : `unlike the dragoness.`}`}
                            She watches on in confusion, as you deftly slip on her snug and comfortable undies.
                            They're a bit big, but not by [i]too[/i] much.
                            You reckon they were a little too small for the lady.
                        [/p]
                        [p]
                            "[color=cyan]${t1 ? `You [b]filthy[/b] underwear-stealing [b]freak[/b]!
                            I hope you [b]die[/b] wearing those!` : t2 ? `I knew you were some kind of [b]deviant[/b],
                            putting on another person's underwear.` : `They look [i]kind of[/i] cute on you, I suppose.`}[/color]"
                            ${pants ? `You tug your ${pantsPopup} up once more. Can't give her too much of a show, right?` : ``}
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
