/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyPantiesReturn(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyPantiesPostChoicesChoice.RETURN;
    var reqController = ctrl.postpanties;
    var changeController = ctrl.postpantiesReturn;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyLocket = true;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            While you would love to [b]torment[/b] the chubby dragoness a bit longer,
                            she [i]did[/i] uphold her end of the deal.
                            She may be a snobby cunt that deserves everything coming her way,
                            but you're an honest kobold.
                            Well, sort of, anyway.
                        [/p]
                        [p]
                            You're not about to spare her feelings, though.
                            Why bother trying to hide the fact that you had the locket all along?
                            If anything, it might be [i]fun[/i] to see her reaction.
                            You reach into your coin pouch.
                            The dragoness' eyes go wide as you pull the pendant from it.
                            She's speechless.
                            Completely [b]flabbergasted[/b].
                            You love the look on her face.
                        [/p]
                        [p]
                            You thank the bitch for her underwear,
                            and for the nice look you got of her [b]ass[/b],
                            then you toss the necklace towards her.
                            She almost hurls herself to the ground in an attempt to catch it.
                            Before she manages to recover, you slip out the door and wisely vacate the area.
                            Hell hath no fury like a dragoness scorned.
                        [/p]
                        [p]
                            The woman may have humiliated you in front of other kobolds,
                            but in the end, it was you who got the last laugh.
                            You insulted her, you degraded her, and you revealed your treachery and deceit to seal the deal.
                            Lording over a dragoness felt [b]exhilarating[/b].
                            You should do it again sometime.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least someone who'll treat you with a bit more [b]dignity[/b] and [b]respect[/b] than the bitchy dragoness.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            Well, she certainly held up her part of the deal.
                            Time for you to honor yours.
                            You crouch down in a corner of the shack, like she did,
                            and pretend to dig through the dirt for a little.
                            Secretly taking the pendant from your coin pouch,
                            you stand upright once more, and turn to face the lady.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees her pendant in your clutches.
                            She even manages a bit of a smile, for a moment.
                            She collects herself, before speaking.
                            "[color=cyan]Good. You found it.[/color]"
                            Yeah.
                            You [i]found[/i] it.
                            Before this gets any more awkward, you hand the woman her necklace.
                        [/p]
                        [p]
                            Once more, a small smile creeps on her face, only to vanish mere moments after.
                            She quickly puts the pendant back around her neck, where it belongs.
                            "[color=cyan]T-thank you.
                            I believe that includes our business.
                            Now if you'll excuse me, I'm going home to put on some new underwear.[/color]"
                            That said, the lady leaves the shack, and storms out of the alleyway.
                        [/p]
                        [p]
                            You, too, exit the abandoned hovel.
                            That was kind of [b]hot[/b].
                            You got to see part of her butt,
                            and you're pretty sure she was [b]completely naked[/b] under her dress when she stormed off.
                            That means she's walking around the kobold-district half-naked.
                            The thought alone excites you to no end.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or maybe another noble to scam out of their underwear.
                        [/p]`;
        } else {
            global.kobold.history.shared.varanar.dayThree.afternoon.rubyName = true;
            toReturn += `
                        [p]
                            Well, after a show like that, it's pretty hard to deny the lady her belongings.
                            You squat down in a corner of the shack,
                            and pretend to dig through the dirt for a little.
                            Secretly taking the pendant from your coin pouch,
                            you stand upright once more, and turn to face her once more.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant.
                            A big, broad smile forms on her face.
                            "[color=cyan]Yes!
                            My locket!
                            You found it![/color]"
                            Overjoyous, the woman approaches you.
                            You hand her the trinket, and she quickly puts it back around her neck, where it belongs.
                        [/p]
                        [p]
                            Then, it is as though she suddenly realizes she isn't wearing anything underneath her robe.
                            Her face turns even redder than before, flushed with embarrassment.
                            "[color=cyan]I'd appreciate it if we could keep what happened here between the two of us.
                            You understand that undressing in front of a stranger in a [i]shady[/i] part of town is not quite lady-like behavior, yes?[/color]"
                            Of course, of course.
                            Your lips are sealed.
                        [/p]
                        [p]
                            "[color=cyan]Good.
                            My name is [b]Ruby[/b].
                            Should we ever meet again, hopefully in more [i]favorable[/i] conditions, well.[/color]"
                            She leans in close, and whispers to you.
                            "[color=cyan][small]Let's just say I might give you a closer look at what's underneath my dress.[/small][/color]"
                            [b]Oh my![/b]
                        [/p]
                        [p]
                            Your heart racing and your body freezing up,
                            you do nothing but stare at her curvy frame as the dragoness turns her back to you, and walks out of the hovel,
                            before exiting the alleyway completely.
                            Did the princess try to [b]seduce[/b] you?!
                            You feel lightheaded.
                            [b]Wow.[/b]
                            You need some air.
                        [/p]
                        [p]
                            You exit the shack yourself, and take a few deep breaths.
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or maybe another dragoness to swoon.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
